#!/usr/bin/python
# -*- coding:utf-8 -*-
import sys
import os

import logging
import time
from PIL import Image,ImageDraw,ImageFont,ImageShow
import traceback
import argparse

parser = argparse.ArgumentParser(description='e-Ink Sheogorath')
parser.add_argument('--debug', action='store_true', help='If true, does not initialize e-Ink, shows images in window')
args = parser.parse_args()

logging.basicConfig(level=logging.DEBUG)

class EPDummy:
    def __init__(self):
        self.width = 122
        self.height = 250
    FULL_UPDATE = 0
    PART_UPDATE = 1
    def display(self, image):
        ImageShow.show(image)
    def displayPartial(self, image):
        ImageShow.show(image)
    def displayPartBaseImage(self, image):
        ImageShow.show(image)
    def init(self, a):
        pass
    def Clear(self, a):
        pass
    def getbuffer(self, image):
        return image

epd = EPDummy()
if not args.debug:
    from lib import epd2in13_V2
    epd = epd2in13_V2.EPD()

try:
    logging.info("Sheogorath.")
    epd.init(epd.FULL_UPDATE)
    epd.Clear(0xFF)

    font15 = ImageFont.truetype('res/Font.ttc', 15)
    font24 = ImageFont.truetype('res/Font.ttc', 24)
    image = Image.new('1', (epd.height, epd.width), 255)
    draw = ImageDraw.Draw(image)
    draw.rectangle([(0,0),(50,50)],outline = 0)
    draw.rectangle([(55,0),(100,50)],fill = 0)
    draw.line([(0,0),(50,50)], fill = 0,width = 1)
    draw.line([(0,50),(50,0)], fill = 0,width = 1)
    draw.chord((10, 60, 50, 100), 0, 360, fill = 0)
    draw.ellipse((55, 60, 95, 100), outline = 0)
    draw.pieslice((55, 60, 95, 100), 90, 180, outline = 0)
    draw.pieslice((55, 60, 95, 100), 270, 360, fill = 0)
    draw.polygon([(110,0),(110,50),(150,25)],outline = 0)
    draw.polygon([(190,0),(190,50),(150,25)],fill = 0)
    draw.text((120, 60), 'e-Paper demo', font = font15, fill = 0)
    draw.text((110, 90), u'', font = font24, fill = 0)
    epd.display(epd.getbuffer(image))
    time.sleep(2)
    
    # read bmp file on window
    logging.info("3.read bmp file on window...")
    epd.Clear(0xFF)
    image1 = Image.new('1', (epd.height, epd.width), 255)  # 255: clear the frame
    bmp = Image.open('res/sheo1.bmp')
    time_image = Image.new('1', (epd.height, epd.width), 255)
    time_draw = ImageDraw.Draw(time_image)
    
    epd.init(epd.FULL_UPDATE)
    #setMode(epd.FULL_UPDATE)
    time_image.paste(bmp, (2,2))    
    epd.displayPartBaseImage(epd.getbuffer(time_image))
    #display(time_image)
    
    epd.init(epd.PART_UPDATE)
    #setMode(epd.PART_UPDATE)
    num = 0
    while (True):
        time_draw.rectangle((140, 90, 250, 122), fill = 255)
        time_draw.text((140, 90), time.strftime('%H:%M:%S'), font = font24, fill = 0)
        epd.displayPartial(epd.getbuffer(time_image))
        #display(time_image)
        time.sleep(0.9)
    epd.Clear(0xFF)
    logging.info("Clear...")
    epd.init(epd.FULL_UPDATE)
    #setMode(epd.FULL_UPDATE)
    epd.Clear(0xFF)
    
    logging.info("Goto Sleep...")
    epd.sleep()
        
except IOError as e:
    logging.info(e)
    
except KeyboardInterrupt:    
    logging.info("ctrl + c:")
    epd2in13_V2.epdconfig.module_exit(cleanup=True)
    exit()
